<template>
  <div class="profile">
    <h4 class="page-title mb-6" v-text="$t('pilotPanel.profile.title')" />

    <vx-card class="mb-6 pt-4 pb-2">
      <!-- Photo -->
      <h4
        class="mb-6 text-center sm:text-left"
        style="color: gray;"
      >{{ `${$t('pilotPanel.profile.photo')}` }}</h4>

      <d-note v-if="firstVisit" text="Now you need to add more information about yourself"></d-note>

      <d-note v-if="noImages" :text="$t('pilotPanel.profile.noPhotoWarning')" color="warning"></d-note>

      <d-image-uploader
        :max-images="1"
        :images-ids="[addForm.avatarId]"
        :load-images="addForm.avatarId !== ''"
        :push-images-to-server="pushImages"
        @uploadedToServer="updateProfile"
        @changedQuantity="changedImagesQuantity"
      />

      <!-- General -->
      <h4
        class="mb-6 text-center sm:text-left"
        style="color: gray;"
      >{{ $t('pilotPanel.profile.generalInfo') }}</h4>

      <div class="vx-row w-full mb-0 sm:mb-6">
        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-input
            v-model="addForm.name"
            validate="required"
            :label="$t('pilotPanel.profile.fullName')"
          />
        </div>
        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-date
            v-model="addForm.birthday"
            minimum-view="day"
            maximum-view="year"
            open-date="1991-04-01"
            format="dd/MM/yyyy"
            :label="$t('pilotPanel.profile.birthday')"
          />
        </div>
      </div>

      <div class="vx-row w-full mb-0 sm:mb-6">
        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-select
            v-model="addForm.country"
            :list="countriesList"
            :text-params="['name']"
            value-param="id"
            :label="$t('pilotPanel.profile.country')"
            autocomplete
            required
          />
        </div>

        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-input
            v-model="addForm.city"
            validate="required|max:16"
            :label="$t('pilotPanel.profile.city')"
          />
        </div>
        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-select
            v-model="addForm.languages"
            :list="langsList"
            :text-params="['name']"
            value-param="id"
            :label="$t('pilotPanel.profile.languages')"
            autocomplete
            multiselect
            required
          />
        </div>
      </div>

      <div class="vx-row w-full mb-0 sm:mb-6">
        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-input
            v-model="addForm.email"
            validate="required|email|max:64"
            :label="$t('pilotPanel.profile.email')"
          />
        </div>

        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-label :text="$t('pilotPanel.profile.phone')" required />
          <vue-tel-input
            v-model="addForm.phone"
            :key="addForm.country"
            valid-characters-only
            :input-options="{ showDialCode: true, tabindex: 0 }"
            :default-country="addForm.country"
            :wrapper-classes="['tel-input']"
          />
        </div>
        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-label :text="$t('pilotPanel.profile.phone2')" />
          <vue-tel-input
            v-model="addForm.phone2"
            :key="addForm.country"
            valid-characters-only
            :input-options="{ showDialCode: true, tabindex: 0 }"
            :default-country="addForm.country"
            :wrapper-classes="['tel-input']"
          />
        </div>
      </div>

      <!-- Password change -->

      <h4
        class="mb-6 text-center sm:text-left"
        style="color: gray;"
      >{{ $t('pilotPanel.profile.changePassword') }}</h4>

      <div class="vx-row w-full row-margin">
        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-input
            v-model="addForm.oldPassword"
            type="password"
            validate="min:4|max:32"
            :label="$t('pilotPanel.profile.oldPassword')"
          />
        </div>

        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-input
            v-model="addForm.newPassword"
            type="password"
            validate="min:4|max:32"
            :label="$t('pilotPanel.profile.newPassword')"
          />
        </div>

        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-input
            v-model="addForm.confirmPassword"
            type="password"
            validate="min:4|max:32"
            :label="$t('pilotPanel.profile.confirmPassword')"
          />
        </div>
      </div>

      <!-- Save -->

      <div class="vx-row w-full mb-0 sm:mb-6">
        <div class="vx-col w-full">
          <vs-button
            type="filled"
            style="margin-top: 22px;"
            :disabled="hasErrors || !correctPassword || !allRequiredFilled"
            :color="hasErrors || !correctPassword || !allRequiredFilled
              ? '#bbbbbb'
              : 'primary'"
            class="action-btn"
            @click="save"
          >{{ firstVisit ? $t('pilotPanel.profile.firstSave') : $t('generalTitles.save') }}</vs-button>
        </div>
      </div>
    </vx-card>
  </div>
</template>

<script lang="ts">
import api from "@/api/profile.api.ts";
import imageApi from "@/api/image.api.ts";
import { Component, Vue } from "vue-property-decorator";
import {
  DInput,
  DDate,
  DSelect,
  DCheckbox,
  DLabel,
  DImage,
  DNote,
  DImageUploader
} from "@/components/d-elements";
import Cookies from "js-cookie";
import { countries_en } from "@/helpers/countries";
import { lang_en } from "@/helpers/languages";
import VueTelInput from "vue-tel-input";
import { mixins } from "vue-class-component";
import { FIRST_VISIT } from "@/helpers/constants";

Vue.use(VueTelInput);

@Component({
  components: {
    DDate,
    DInput,
    DSelect,
    DCheckbox,
    DLabel,
    DImage,
    DNote,
    DImageUploader
  }
})
export default class Profile extends Vue {
  private addForm = {
    avatarId: "",
    name: "",
    country: "",
    city: "",
    languages: ["en"],
    currency: "",
    email: "",
    phone: "",
    phone2: "",
    bankNumber: "",
    oldPassword: "",
    newPassword: "",
    confirmPassword: "",
    birthday: ""
  };

  private countriesList = countries_en;
  private langsList = lang_en;
  private avatar = "";
  private pushImages = false;
  private noImages = false;

  get correctPassword() {
    if (this.addForm.newPassword || this.addForm.confirmPassword) {
      return (
        this.addForm.newPassword === this.addForm.confirmPassword &&
        this.addForm.oldPassword
      );
    }

    return true;
  }

  get hasErrors() {
    // @ts-ignore
    return this.errors.items.length > 0;
  }

  get firstVisit() {
    return Cookies.get(FIRST_VISIT) || false;
  }

  get allRequiredFilled() {
    return (
      this.addForm.name &&
      this.addForm.country &&
      this.addForm.city &&
      this.addForm.languages.length > 0 &&
      this.addForm.email &&
      this.addForm.phone.length > 8
    );
  }

  created() {
    this.getProfile();
  }

  private async getProfile() {
    await api.getProfile().then(response => {
      this.addForm = response.data;

      if (this.addForm.country) {
        this.addForm.country = this.addForm.country.toUpperCase();
      }
    });
  }

  private async updateProfile(imagesIds) {
    this.pushImages = false;
    this.addForm.avatarId = imagesIds[0] || "";
    await api.updateProfile(this.addForm).then(response => {
      if (response.status === 200) {
        this.$store.dispatch("appState/showAlert", {
          mode: "success",
          title: this.$t("notifications.successfully"),
          text: this.$t("notifications.saved")
        });

        if (this.firstVisit) {
          Cookies.remove(FIRST_VISIT);
          this.$router.push("/my-aircraft");
        }
      }
    });
  }

  private changedImagesQuantity(val) {
    if (val === 0) {
      this.noImages = true;
    } else {
      this.noImages = false;
    }
  }

  private save() {
    this.pushImages = true;
  }
}
</script>

<style lang="scss">
.profile {
  .tel-input {
    height: 38px;
    border: 1px solid rgba(0, 0, 0, 0.2);
  }
}
</style>